struct template
{
	//nint, intid are determined from external files
	//position can be evaluated by template_position_init
	//above objects can be used many times
	//nvar, varlist should be read from external files
	//nsol, sol and rel are determined by search_relation

	//number of integrals, depends on G only, get from file
	int nint;

	//list of global integral ID, depends on G only, get from file
	struct list_int intid0;
	struct list_int * intid;

	//each MI corresponds to a list of integrals which have nonzero projection, find their position
 	//size: db->nmaster * tp->nint
 	//-1: zero projection, other: position
 	//init once and for all
 	struct table_int posi0;
	struct table_int * posi;

	//absorb table
	//size: tp->nint * size
	struct table_int abs0;
	struct table_int * abs;

	//number of variables after absorb
	int nvar;

	//each variable is a coefficient of a monomial s*I, so we can define it with local integral_id and monomial_id
	//varlist: nvar * 2
	//has been absorbed and is used during search
	struct table_int varlist0;
	struct table_int * varlist;

	//number of solution, generated by solving function
	int nsol;

	//solution, generated by solving function
	struct table_llu sol0;
	struct table_llu * sol;

	//relation evaluated at the last phase space point
	struct table_llu rel0;
	struct table_llu * rel;
};

void template_integrals_init(struct template * tp, char * dir);
void template_position_init(struct template * tp, struct database * db);
void template_absorb_init(struct template * tp, int size);
void template_init(struct template * tp, struct database * db, char * dir, int size);
int absorb_larger(struct list_int * a, struct list_int * b);
int absorb_test(struct template * tp, struct kinematics * kn, int localid, int monoid);
void template_config_init(struct template * tp, struct kinematics * kn, char * dir, char * key);
void template_absorb_append(struct template * tp);
void template_relation_create(struct template * tp, struct database * db, struct kinematics * kn);
void template_solution_write(struct template * tp, char * dir);
void template_solution_read(struct template * tp, char * dir);
void template_config_clear(struct template * tp);
void template_clear(struct template * tp);